#include "diskuser.h"
#include "ui_diskuser.h"
#include <QFile>
#include <QFileDialog>
#include <QTextStream>
#include <QThread>


DiskUser::DiskUser(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::DiskUser)
{
    ui->setupUi(this);
}

DiskUser::~DiskUser()
{
    delete ui;
}


void DiskUser::killloop(){//function called when we get a signal to kill loop :)
    killflag=true; //set flag to true so loop will get stopped
}


void DiskUser::on_pushButton_clicked()
{
    ui->pushButton->setEnabled(false); //dont let opponent.. err.. user destroy things...

    killflag=false;
	static int currentIcon = 1;
	QIcon icon1(":/1a.ico");
	QIcon icon2(":/2a.ico");
	QIcon icon3(":/3a.ico");
	QIcon icon4(":/4a.ico");
	QIcon icon5(":/5a.ico");
	QIcon icon6(":/6a.ico");
	QIcon defaultOne(":/1.ico");


    QString fileName = QFileDialog::getSaveFileName(this, tr("Save File"), QString(),//now lets ask user where he wants to have dummy file
													tr("Text Files (*.txt)"));//allowed file types
    if (!fileName.isEmpty()) { //check if file was choosen
        QFile file(fileName);//now lets declare that we are going to actually use chosen file
        if (!file.open(QIODevice::ReadWrite)) { //if write error, throw error msg
            abort();//If we cannot write to this file, we dont give a shit about user. lets just force crash so we won't be in fishy situation.
        } else {
            ui->statbar->setStyleSheet("background-color:red;");
            file.write("dummy file");//lets inform potential opener that this file is totally useless
            int temp=0;
            int subit=0;
            int read=ui->horizontalSlider->value();
            for(;;){//now lets make some ifinite loops :D
                //now lets make some noice into file, so we are //REALLY// using it, and disk //REALLY// sees stuff coming around
                file.seek(file.pos()-4);
				file.write("dumm");
                file.flush();//no buffering, nononono I dont want you to do so
                file.close();                   //need small refresh
                file.open(QIODevice::ReadWrite);//need small refresh
                file.seek(file.pos()-4);
				file.write("dumm");
                file.flush();//no buffering, nononono I dont want you to do so
                //okay that's enough.
                if(killflag){
                    break; //if user clicked stop button, lets juuuuuuust quit loop and stop annoying the hell on him (or rather his disk).
                } else
                {//sleep section
                    temp=1;//our temporary counter how many miliseconds we are sleeping
                    subit=0;//subiterator
                    read=ui->horizontalSlider->value();
                    while (temp<read){
                    QThread::msleep(20); //we want to sleep 20 miliseconds
                    temp+=20;//now we will count that 20 miliseconds.

                    //because we took aaaaall of the timeing and now we are in loop, we have no way
                    //to check other parts of thread, and get back to event loop. now we are stuck...
                    //any solutions? yeah! just call event loop manually ;)
                    QApplication::processEvents();

                    //ok, everything fancy dandy, riiight... buuuut what if user has 10 s delay and he want to change it to like 400ms? than effect will be in like...
                    //10 seconds. lets fix it, by checking up every 160ms (using sub-iterator) slider and updating value. while loop will automatically handle rest :)
                    subit++;
                    if (subit==8){//8*20=160ms - will exec every 160 ms
                        read=ui->horizontalSlider->value();//will update read value
						//dynamic icon handler
						if (currentIcon==1){
							DiskUser::setWindowIcon(icon2);
							currentIcon = 2;
						}
						else if (currentIcon==2){
							DiskUser::setWindowIcon(icon3);
							currentIcon = 3;
						}
						else if (currentIcon==3){
							DiskUser::setWindowIcon(icon4);
							currentIcon = 4;
						}
						else if (currentIcon==4){
							DiskUser::setWindowIcon(icon5);
							currentIcon = 5;
						}
						else if (currentIcon==5){
							DiskUser::setWindowIcon(icon6);
							currentIcon = 6;
						}
						else if (currentIcon==6){
							DiskUser::setWindowIcon(icon1);
							currentIcon = 1;
						}

                        subit=0;//will reset counter
					}if(killflag){
						file.remove();
						break; //just to keep program more responsive, if we had this 20 ms luck with stop button, lets just stop, okay?
					}
                    }if(killflag){
                        break; //since previous break statement works only for while loop not for for loop, if it broke, we may want to actually break.
						file.remove();
					}
                }
            }
            file.close(); //now we need to close file and be nice :)
            ui->statbar->setStyleSheet("background-color:lime;");//will inform user - im not runnin!
        }
    }
	DiskUser::setWindowIcon(defaultOne);
    ui->pushButton->setEnabled(true);
}

void DiskUser::on_pushButton_2_clicked() //ok, if we click stop, we setup kill infinite loop flag to true, which will kill it next iteration
{
    DiskUser::killloop();
}

void DiskUser::on_horizontalSlider_valueChanged(int value)
{
    ui->timecounter->setText(QString::number(value));
}
